// Copyright (C) 1994 SuperChunkyCode All rights reserved.
// $Revision: 1.1 $
// November, 1994 Michael Papka
// Last Revised $Date: 1994/12/13 15:46:00 $
//
//
// Log Messages 
/* $Log: $ */
// Standard Headers
#include <iostream.h>

// Private Headers
#include <sharedmemory.h>
#include <testClass.h>

extern int _SHARED_MEMORY_REQUEST;  // Defined in sharedmemory.h used to 
				    // change amount of shared memory 
				    // requested from default to some
				    // given amount. Note: If you want
				    // a different amount of shared memory
				    // than default you must set this 
				    // variable before the first snew
				    // call.  The request is made in
				    // megabytes.

float	    *largeArray;
TestClass   *testClass;
int	    *intArray;

main()
{
    cout << "Sample Program Testing Features of snew()" << endl;

    _SHARED_MEMORY_REQUEST = 48;    // Requesting 48 megabytes of shared 
				    // memory instead of default 32.
				    
    largeArray = snew float[10000]; // Allocation of 10000 Floats
    testClass = snew TestClass;	    // Allocation of Class
    intArray = new int[10000];	    // Non-shared Memory Int Array
    
    cout << "Initialize Arrays" << endl;
    
    int i;
    for(i=0;i<10000;i++)
	largeArray[i] = (float)i;
    for(i=0;i<10000;i++)
	intArray[i] = i;
	
    for(i=0;i<10;i++)
	cout << "Float Array [" << i << "] " << largeArray[i] << endl;
    for(i=0;i<10;i++)
	cout << "Int Array [" << i << "] " << intArray[i] << endl;
    
    testClass->print();
    cout << "Output from member function " << testClass->raise() << endl;
    
    void    functionCall(void *);
    
    sproc(functionCall,  PR_SALL, 0);
    
    void    functionCall1();
    switch(fork())
    {
	default: break;
	case 0: functionCall1();
		exit(0);
    }// End of switch
    
    for(i=0;i<10;i++)
    {
	cout << "Float Array [" << i << "] ";
	cout << largeArray[i] << " After sproc and fork. " << endl;
    }// End of FOR
    for(i=0;i<10;i++)
    {
	cout << "Values of Int Array [" << i << "] ";
	cout << intArray[i] << " After sproc and fork. " << endl;
    }// End of FOR
	
    cout << "After Forks" << endl;
    testClass->print();
    cout << "Output from member function " << testClass->raise() << endl;
    
    sdelete [] largeArray;
    sdelete testClass;
    delete [] intArray;
}

void
functionCall(void *)
{
    extern float *largeArray;
    extern int	 *intArray;
    extern TestClass *testClass;
    
    cout << "Function: functionCall has been entered" << endl;
    
    cout << "Output from member function within function call ";
    cout << testClass->raise() << endl;
    
    cout << "Printing First 10 values of each array" << endl;
    int i;
    for(i=0;i<10;i++)
	cout << "Float Array [" << i << "] " << largeArray[i] << endl;
    for(i=0;i<10;i++)
	cout << "Int Array [" << i << "] " << intArray[i] << endl;
    
    cout << "Changing Values" << endl;
    
    for(i=0;i<10000;i++)
	largeArray[i] += largeArray[i];
    for(i=0;i<10000;i++)
	intArray[i] += intArray[i];
    
    for(i=0;i<10;i++)
	cout << "Modified Float Array [" << i << "] " << largeArray[i] << endl;
    for(i=0;i<10;i++)
	cout << "Modified Int Array [" << i << "] " << intArray[i] << endl;
}// End of functionCall()

void
functionCall1()
{
    extern float *largeArray;
    extern int	 *intArray;
    extern TestClass *testClass;
    
    cout << "Function: functionCall1 has been entered" << endl;
    
    cout << "Output from member function within function call ";
    cout << testClass->raise() << endl;
    
    cout << "Printing First 10 values of each array" << endl;
    int i;
    for(i=0;i<10;i++)
	cout << "Float Array [" << i << "] " << largeArray[i] << endl;
    for(i=0;i<10;i++)
	cout << "Int Array [" << i << "] " << intArray[i] << endl;
    
    cout << "Changing Values" << endl;
    
    for(i=0;i<10000;i++)
	largeArray[i] += largeArray[i];
    for(i=0;i<10000;i++)
	intArray[i] += intArray[i];
    
    for(i=0;i<10;i++)
	cout << "Modified Float Array [" << i << "] " << largeArray[i] << endl;
    for(i=0;i<10;i++)
	cout << "Modified Int Array [" << i << "] " << intArray[i] << endl;
}// End of functionCall1()
